#include "jss/actor.hpp"
#include <future>
#include <iostream>
#include <chrono>
#include <thread>

class DeepThought{
  jss::actor internal_actor;

  struct find_the_answer{std::promise<int> promise;};

  static void actor_loop() {
    for(;;){
      jss::actor::receive().match<find_the_answer>(
          [](find_the_answer fta) {
            std::cout<<"Thinking\n";
            std::this_thread::sleep_for(
              std::chrono::seconds(5));
            std::cout<<"Answer ready\n";
            fta.promise.set_value(42);
          });
    }
  }
    

public:
  DeepThought():
    internal_actor(actor_loop)
  {}
    
  ~DeepThought() {
    internal_actor.stop();
  }

  std::future<int> findTheAnswerToLifeTheUniverseAndEverything()
  {
    find_the_answer fta;
    std::future<int> res=fta.promise.get_future();
    internal_actor<<std::move(fta);
    return res;
  }
};

int main(){
  DeepThought dt;
  auto answer=dt.findTheAnswerToLifeTheUniverseAndEverything();
  std::cout<<"Doing stuff\n";
  std::this_thread::sleep_for(std::chrono::seconds(2));
  std::cout<<"Waiting\n";
  answer.wait();
  std::cout<<"The answer is "<<answer.get()<<std::endl;
}


    
