
-module(buffer2).
-mode(compile).
-export([source/2, target/0]).

source(0, Target_PID) ->
    Target_PID ! finished,
    io:format("source finished~n", []);

source(N, Target_PID) ->
    io:format("source sending message ~w~n", [N]),
    Target_PID ! {message,N},
    source(N - 1, Target_PID).

dump_messages() ->
    receive
        {message,N} ->
            io:format("Target received message ~w~n", [N]),
            dump_messages()
    end.

target() ->
    receive
        finished ->
            io:format("Target finished~n", []),
            dump_messages();
        _ ->
            io:format("Unexpected message~n", []),
            target()
    end.

main(_) ->
    Target_PID = spawn(?MODULE, target, []),
    spawn(?MODULE, source, [5, Target_PID]),
    timer:sleep(1000).
