package accu2012

import scala.actors.Actor
import scala.actors.Actor._

case object Ping
case object Pong
case object Finished

class Ping(count: Int, pong: Actor) extends Actor {
  def act() {
    var pingsLeft = count
    while(pingsLeft > 0) {
      pong ! Ping
      receive {
        case Pong =>
          Console.println("Ping received pong")
      }
      pingsLeft -= 1
    }
    Console.println("Ping finished")
    pong ! Finished
  }
}

class Pong extends Actor {
  def act() {
    loop {
      react {
        case Ping =>
          Console.println("Pong received ping ")
          sender ! Pong
        case Finished =>
          Console.println("Pong finished")
          exit()
      }
    }
  }
}

object pingpong extends App {
  val pong = new Pong
  val ping = new Ping(5, pong)
  ping.start
  pong.start
}
