#include <jss/actor.hpp>
#include <iostream>

struct ping { jss::actor_ref sender; };
struct pong {};
struct finished {};

void pingfunc(unsigned n,jss::actor_ref pong_id){
  while(n--) {
    pong_id << ping{jss::actor::self()};
    jss::actor::receive().match<pong>(
      [](pong){
        std::cout<<"ping received pong\n";
      });
  }
  pong_id << finished();
  std::cout<<"ping finished\n";
}

void pongfunc() {
  bool done=false;
  while(!done) {
    jss::actor::receive()
      .match<ping>(
        [](ping p){
          std::cout<<"pong received ping\n";
          p.sender << pong();
        })
      .match<finished>(
        [&](finished){
          std::cout<<"pong finished\n";
          done=true;
        });
  }
}


int main() {
  jss::actor pong(pongfunc);
  jss::actor ping(pingfunc,5,jss::actor_ref(pong));
}

